; 
    include \masm32\include\masm32rt.inc
    .586
    .xmm
	include \masm32\macros\timers.asm

.code
; 
;32 or 64 bit Binary-to-ASCII Decimal Conversion Suppressing Leading Zeros
; by Paul Dixon		                ;
option prologue:none			    ; turn it off
option epilogue:none				;
align 16 
uqword proc lpbuf:DWORD, lpNumber:DWORD    ;unsigned DWORD to ASCII
	    mov	ecx, [esp+2*4]      ; lp qword number 
	    mov	eax,	[ecx+4]            ; eax->low dword
	    mov	edx,	[ecx]        ; edx->high dword 
        mov	ecx, [esp+1*4]      ; ecx, lpbuf 
        or     edx,edx               ;if top word is not used then..
        jz     udword                ; .. use unsigned Dword routine as it;s faster
        push ebp                   ;save registers that need to be saved
        push esi
        mov	ebp,	eax          	; save a copy of low word for later
        mov	esi,	edx          	; save a copy of high word for later
        mov	pAnswer,	ecx     	; save a copy of buffer pointer for later, don;t stack it or it;s awkward to get back
;do 64 bit multiply by 2^110\1e14+1 to make it more likely I get no rounding errors = 0B424DC35 095CD810h
;this is a 4 part operation, LOxLO, LOxHI, HIxLO, HIxHI and add the 4 results offset appropriately
        mov	ecx,	095CD810h     	; 2^110\1e14+1 low word
        mul	ecx                			;
        mov	eax,	esi            		; get number high word, LSBs of MUL not needed so they;re ignored
        nop
        push edi
        push ebx 
        mov	edi,	edx            		; save high word of result
        mul	ecx                			; now do high word mul
        mov	ecx,	0B424DC35h     ; get ready for other half of MUL
        add	edi,	eax            		; Add low word into result
        adc	edx,	0              		    ; and handle the possible carry
        mov	eax,	ebp            		; Get low word of number again
        mov	ebx,	edx            		; save high word of answer
        mul	ecx                			; do next part
        add	edi,	eax            		; add into answer
        mov	eax,	esi            		; get high word of number
        adc	ebx,	edx            		; add it in to answer #####? possible carry to higher word? probably not..
        mul	ecx                			; do final mul
        mov	ecx,	1000000        	; ready for later
        add	ebx,	eax            		; add in result
        adc	edx,	0              		    ; and carry
        add	edi,	16384          		; round up last bit to decrease error to within that required.
        adc	ebx,	0
        adc	edx,	0
        shrd	edi,	ebx, 14        		;correct for the 14 bit shift used to increase accuracy
        shrd	ebx,	edx, 14
        shr	edx,	14    		         	;edx contains top 6 digits, edi:ebx contain the information to get the next 6 digits
        			                            ; edx = 2D093h ebx= 70D42573h   edi=603A5EDAh	
;64 bit multiply done
;result in edx:ebx:edi  , original number in esi:ebp
;x 1000000 to get next 6 digits
        mov	eax,	edi
        mov	esi,	edx            		;save top6 in esi
        mul	ecx
        mov	eax,	ebx                	;do low word x1 000 000
        mov	ebx,	edx                	;
        mul	ecx                    		;do high word x 1 000 000
        add	eax,	ebx                	;add both together
        adc	edx,	0
        mov	ebx,	edx                	;save 2nd 6 in ebx
;now get ((top6 x 1e6) + next6)*1e8 and sub from original number to leave last 8 digits
;since the 8 digits we want are all contained in the low word we can completely ignore the high word
;this allows imul and does away with carries to the high word
        mov	eax,	esi               		;get top 6
        imul	eax,	ecx              		;top 6 x 1 000 000
        mov	ecx,	100000000
        add	eax,	ebx               		;top6 x 1 000 000 + next 6
        imul	eax, 	ecx
        sub	ebp,	eax               		;ebp=last 8 digits
;20 digits broken into 6,6,8 now display them
;esi=top6, ebx=next 6, ebp=last 8
;do top 6 digits
        mov	eax,	esi    		; get top 6 digits
        mov	edi,	68DB9h         ; =2^32\10000+1
        mul	edi
        mov	esi,	pAnswer  ;offset TimeBuffer 	            ;get pointer into answer buffer
        mov	ecx,	100                 		;multiplier for later
        jnc	qnextrw1            		;if zero, supress them by ignoring
        cmp	edx,	9                  		;1 digit or 2?
        ja	    qZeroSupressedo    		;2 digits, just continue with pairs of digits to the end
        mov	edx,	dword ptr chartab[edx+edx]     	;look up 2 digits
        mov	[esi],	dh               		;but only write the 1 we need, supress the leading zero
        inc	esi                    		;update pointer by 1
        jmp	QZoS1              			;continue with pairs of digits to the end
qnextrw1:
        mul	ecx                    		;get next 2 digits
        jnc	qnextrw2            		;if zero, supress them by ignoring
        cmp	edx,	9                  		;1 digit or 2?
        ja	    QZoS1a             		;2 digits, just continue with pairs of digits to the end
        mov	edx,	dword ptr chartab[edx+edx]     	;look up 2 digits
        mov	[esi],	dh               		;but only write the 1 we need, supress the leading zero
        inc	esi                    		;update pointer by 1
        jmp	QZoS2              			;continue with pairs of digits to the end
qnextrw2:
        mul	ecx                    		;get next 2 digits
        jnc	qnextrw3            		;if zero, supress them by ignoring
        cmp	edx,	9                  		;1 digit or 2?
        ja	    QZoS2a     			;2 digits, just continue with pairs of digits to the end
        mov	edx,	dword ptr chartab[edx+edx]     	;look up 2 digits
        mov	[esi],	dh               		;but only write the 1 we need, supress the leading zero
        inc	esi                    		;update pointer by 1
        jmp	QZoS3              			;continue with pairs of digits to the end
;next 6 digits
qnextrw3:
        mov	eax,ebx              		;get 2nd 6 digits
        mov	ebx, 28F5C29h          	;=2^32\100+1  ready for later
        mul	edi                    		;edi=2^32\10000+1
        jnc	qnextrw4            		;if zero, supress them by ignoring
        cmp	edx,	9                  		;1 digit or 2?
        ja	    QZSo3a   			;2 digits, just continue with pairs of digits to the end
        mov 	edx,	dword ptr chartab[edx+edx]     	;look up 2 digits
        mov 	[esi],	dh               		;but only write the 1 we need, supress the leading zero
        inc 	esi                   		;update pointer by 1
        jmp	QZSo4   		           ;continue with pairs of digits to the end
  qnextrw4:
        mul 	ecx                    		;get next 2 digits
        jnc	QZSo5             			;if zero, supress them by ignoring
        cmp	edx,	9                  		;1 digit or 2?
        ja	    QZSo4a             		;2 digits, just continue with pairs of digits to the end
        mov	edx,	dword ptr chartab[edx+edx]     	;look up 2 digits
        mov	[esi],	dh    		      	;but only write the 1 we need, supress the leading zero
        inc	esi                    		;update pointer by 1
        jmp	QZSo5              			;continue with pairs of digits to the end
;done top 10 digits
;since we took a short cut to the DWORD routine at the start we can never get beyond here
;as the DWORD routine would handle it instead.
;At this point we are guaranteed to have exactly 10 digits to print so just jump to the relevant spot.
qZeroSupressedo:
        mov	edx,	dword ptr chartab[edx+edx] ;look up the 2 digits
        mov  [esi],	dx
        add	esi,	2
QZoS1:
        mul	ecx
QZoS1a:
        mov	edx,	dword ptr chartab[edx+edx] ;look up the 2 digits
        mov	[esi],	dx
        add	esi,	2
QZoS2:
        mul	ecx
QZoS2a:
        mov	edx,	dword ptr chartab[edx+edx] ;look up the 2 digits
        mov	[esi],	dx
        add	esi,	2
sj:
QZoS3:
;do next 6 digits
        mov	eax,	ebx                	;get 2nd 6 digits
        mov	ebx,	28F5C29h	;=2^32\100+1  ready for later
        mul	edi                    	;edi=2^32\10000+1
QZSo3a:
        mov	edx,	dword ptr chartab[edx+edx]
        mov	[esi],	dx
        add	esi,	2
QZSo4:
        mul	ecx
QZSo4a:
        mov	edx,	dword ptr chartab[edx+edx]
        mov	[esi],	dx
        add	esi,	2
QZSo5:
        mul	ecx
;QZSo5a:
        mov	edx,	dword ptr chartab[edx+edx]
        mov	[esi],	dx
        add	esi,	2
;do final 8 digits
        mov	eax,	ebp                	;get last 8 digits
        mul	ebx                    	;ebx=2^32\100+1
        mov	eax,	edx
        mov	ebx,	edx
        mul	edi                    	;edi=2^32\10000+1
        mov	edx,	dword ptr chartab[edx+edx]     ;look up next 2 digits
        mov	[esi],	dx
        add	esi,	2
        mul	ecx
        mov	edx,	dword ptr chartab[edx+edx]     ;look up next 2 digits
        mov	[esi],	dx
        add	esi,	2
        mul	ecx
        mov	edx,	dword ptr chartab[edx+edx]    ;look up next 2 digits
        mov	[esi],	dx
        add	esi,	2
        mov	eax,	ebx               	;first 6 digits of last 8
        imul	eax, 	ecx              	;x100 to shift into place
        pop  ebx
        pop  edi   
        mov	edx,	ebp               	;last 8 - 6 just done gives final 2 digits
        sub	edx,	eax               	;look up final 2 digits
        mov	edx,	dword ptr chartab[edx+edx]
        mov	[esi],	dx
        add	esi,	2
        mov	byte ptr [esi],0     	;need to zero terminate
        pop  esi
        pop  ebp
AllDone:
        ret    2*4
udword:
    push edi                   ;save registers that need to be saved
    push esi
    mov  esi, ecx      ; sptr
    mov  edi,eax                ;eax= x ;save a copy of the number
    mov  edx, 0D1B71759h        ;=2^45\10000    13 bit extra shift
    mul   edx                    ;gives 6 high digits in edx
    mov  eax,68DB9h            ;=2^32\10000+1
    shr    edx,13                 ;correct for multiplier offset used to give better accuracy
    jz short skiphighdigits          ;if zero then don;t need to process the top 6 digits
    mov  ecx,edx                ;get a copy of high digits
    imul  ecx,10000             ;scale up high digits
    sub   edi,ecx                ;subtract high digits from original. EDI now = lower 4 digits
    mul   edx                    ;get first 2 digits in edx
    mov  ecx,100                ;load ready for later
    jnc short next1                  ;if zero, supress them by ignoring
    cmp  edx,9                  ;1 digit or 2?
    ja  short ZeroSupressed          ;2 digits, just continue with pairs of digits to the end
    mov  edx,dword ptr chartab[edx*2]     ;look up 2 digits
    mov  [esi],dh               ;but only write the 1 we need, supress the leading zero
    inc    esi                    ;update pointer by 1
    jmp short ZS1               ;continue with pairs of digits to the end
next1:
    mul   ecx                    ;get next 2 digits
    jnc short next2                  ;if zero, supress them by ignoring
    cmp  edx,9                  ;1 digit or 2?
    ja  short ZS1a                   ;2 digits, just continue with pairs of digits to the end
    mov  edx,dword ptr chartab[edx*2]     ;look up 2 digits
    mov  [esi],dh               ;but only write the 1 we need, supress the leading zero
    inc    esi                    ;update pointer by 1
    jmp short ZS2               ;continue with pairs of digits to the end
next2:
    mul   ecx                    ;get next 2 digits
    jnc short next3                  ;if zero, supress them by ignoring
    cmp  edx,9                  ;1 digit or 2?
    ja  short ZS2a                   ;2 digits, just continue with pairs of digits to the end
    mov  edx,dword ptr chartab[edx*2]     ;look up 2 digits
    mov  [esi],dh               ;but only write the 1 we need, supress the leading zero
    inc    esi                    ;update pointer by 1
    jmp short ZS3               ;continue with pairs of digits to the end
next3:
skiphighdigits:
    mov  eax,edi                ;get lower 4 ditigs
    mov  ecx,100
   mov   edx,28F5C29h          ;2^32\100 +1
    mul   edx
    jnc short next4                  ;if zero, supress them by ignoring
    cmp  edx,9                  ;1 digit or 2?
    ja  short ZS3a                   ;2 digits, just continue with pairs of digits to the end
    mov  edx,dword ptr chartab[edx*2]     ;look up 2 digits
    mov  [esi],dh               ;but only write the 1 we need, supress the leading zero
    inc    esi                    ;update pointer by 1
    jmp short  ZS4               ;continue with pairs of digits to the end
next4:
    mul   ecx                    ;this is the last pair so don;t supress a single zero
    cmp  edx,9                  ;1 digit or 2?
    ja  short ZS4a                   ;2 digits, just continue with pairs of digits to the end
    mov  edx,dword ptr chartab[edx*2]     ;look up 2 digits
    mov  [esi],dh               ;but only write the 1 we need, supress the leading zero
    mov  byte ptr [esi+1],0     ;zero terminate string
    jmp short  xit               ;all done
ZeroSupressed:
    mov  edx,dword ptr chartab[edx*2]     ;look up 2 digits
    mov  [esi],dx
    add   esi,2                  ;write them to answer
ZS1:
    mul ecx                    ;get next 2 digits
ZS1a:
    mov edx,dword ptr chartab[edx*2]     ;look up 2 digits
    mov [esi],dx               ;write them to answer
    add esi,2
ZS2:
    mul ecx                    ;get next 2 digits
ZS2a:
    mov edx,dword ptr chartab[edx*2]     ;look up 2 digits
    mov [esi],dx               ;write them to answer
    add esi,2
ZS3:
    mov eax,edi                ;get lower 4 digits
    mov edx,28F5C29h         ;2^32\100 +1
    mul edx                    ;edx= top pair
ZS3a:
    mov edx,dword ptr chartab[edx*2]     ;look up 2 digits
    mov [esi],dx               ;write to answer
    add esi,2                  ;update pointer
ZS4:
    mul ecx                    ;get final 2 digits
ZS4a:
    mov edx,dword ptr chartab[edx*2]     ;look them up
    mov [esi],dx               ;write to answer
    mov byte ptr [esi+2],0     ;zero terminate string
xit:
    pop esi                    ;restore used registers
    pop edi 
    ret 8
uqword endp    
option prologue:prologuedef                   ; turn back on the defaults
option epilogue:epiloguedef                   ;

; 32 and 64 bit Binary-to-ASCII Decimal Conversion Suppressing Leading Zeros
; by Lingo			;
option	prologue:none	; turn it off
option	epilogue:none	;
align	16 			;									
b2a3264	proc	lpbuf:DWORD, lpNumber:DWORD	; unsigned QWORD or DWORD to ASCII	
	mov	edx,	[esp+2*4]	; 
  	mov	eax,	0D1B71759h	; 
	mov	[esp+2*4], edi	; 
	cmp	dword ptr [edx], 0	; 
	jne	Lb2a64	;
; 32 bit Binary-to-ASCII Decimal Conversion Suppressing Leading Zeros
    mov	edi,	[edx+4]	;
    sub	esp,	3*4	; 
	mov	[esp+1*4], esi	;
 	mul	edi		;
	mov	ecx,	[esp+1*4+3*4]	;
	shr	edx,	13	;
	mov	eax,	68DB9h	;
	je	LoNext3	;
	imul	esi,	edx, 10000	;
	sub	edi,	esi	;
	mul	edx		;
	mov	esi,	100	;
	jnc	LoNext1	;
	cmp	edx,	9	;
	jc     Lo0
	mov	edx,	dword ptr chartab[edx+edx]	; 
	add  ecx, 8      
	mov	[ecx-8], edx	;
Lo1:				;
	mul	esi		; 
Lo1a:				;
	mov	edx,	dword ptr chartab[edx+edx]	; 
	mov	[ecx-6], edx	; 
Lo2:				;
	mul	esi		; 
Lo2a:				;
	mov	edx,	dword ptr chartab[edx+edx]	; 
	mov	[ecx-4], edx	; 
Lo3:				;
	mov	eax,	28F5C29h	; 
	mul	edi		; 
Lo3a:				;
	mov	edx,	dword ptr chartab[edx+edx]	; 
	mov	[ecx-2], edx	; 
Lo4:				;
	mul	esi		; 
Lo4a:				;
	mov	esi,	 [esp+1*4]	; 
	add	esp,	 3*4	; 
	mov	edi,	 [esp+2*4]	; 
	movzx	edx,	 word ptr chartab[edx+edx]	; 
	lea	eax,	 [ecx+2]	;
	mov	[ecx], edx	; 
	ret	2*4		; 
align 16
Lo0:
	add	edx,	30h	;
	mov	[ecx], edx	;
    add	ecx,7	;
	jne	Lo1		;
align 16				;
LoNext1:				;
	mul	esi		; 
	jnc	LoNext2	; 
	cmp	edx,	9	; 
	lea	ecx,	[ecx+6]	;
	ja	Lo1a		; 
	add	edx,	30h	;
	sub	ecx,	1	; 
	mov	[ecx-5], edx	; 
	jnz	Lo2		; 
align 16				;
LoNext2:				;
	mul	esi		; 
	jnc	LoNext3	; 
	cmp	edx,	9	; 
	lea	ecx,	[ecx+4]	;
	ja	Lo2a		; 
	add	edx,	30h	;
	sub	ecx,	1	; 
	mov	[ecx-3], edx	; 
	jnz	Lo3		; 
align 16				;
LoNext3:				;
	mov	eax,	28F5C29h	; 
	mul	edi		; 
	mov	esi,	100	;
	jnc	LoNext4	; 
	cmp	edx,	9	; 
	lea	ecx,	[ecx+2]	;
	ja	Lo3a		; 
	add	edx,	30h	;
	sub	ecx,	1	; 
	mov	[ecx-1], edx	; 
	jnz	Lo4		; 
align 16				;
LoNext4:				;
	mul	esi		; 
	cmp	edx,	9	; 
	ja	Lo4a		; 
	mov	esi,	[esp+1*4]	; 
	add	edx,	30h	;
	mov	edi,	[esp+2*4+3*4]	; 
	add	esp,	3*4	; 
	mov	[ecx], edx	; 
	lea	eax,	[ecx+1]	;
	ret	2*4		; 
				;
; 64 bit Binary-to-ASCII Decimal Conversion Suppressing Leading Zeros
align 16				;
Lb2a64:				;
    mov	edi,	[edx+4]	;
	mov	eax,	095CD810h  	;
    mov	esi,	[edx]	;
	sub	esp,	3*4	; 
	mul	edi		;
	mov	[esp+2*4+3*4], ebp	;
	mov	eax,	095CD810h  	;
	mov	ebp,	edx	;
	mul	esi		;
	mov	[esp], ebx	;
	add	ebp,	eax	;
	mov	eax,	0B424DC35h	;
	adc	edx,	0	;
	mov	ebx,	edx	;
	mul	edi		;
	add	ebp,	eax	;
	mov	eax,	0B424DC35h            	;
	adc	ebx,	edx                
	mul	esi		;
	add	ebx,	eax	;
	adc	edx,	0	;
	add	ebp,	16384	;
	adc	ebx,	0	;
	adc	edx,	0	;
	shrd	ebp,	ebx, 14	;
	mov	eax,	1000000	;
	shrd	ebx,	edx, 14	;
	mov	esi,	edx	; 
	mul	ebp		;
	shr	esi,	14 
	mov	eax,	1000000	;
	mov	ecx,	edx    	;
	mul	ebx		; 
	add	ecx,	eax	; 
	adc	edx,	0	;
	imul	ecx,	esi, 1000000	; 
   	mov	ebx,	edx	; 
	add	ecx,	edx	; 
   	imul	ecx,	100000000	;
	sub	edi,	ecx	; 
	mov	eax,	68DB9h	; 
	mul	esi		; 
	mov	ecx,	[esp+1*4+3*4]	; 
	mov	esi,	100	; 
	jnc	JoNext1	; 
	cmp	edx,	9	; 
	jna	Jo0		; 
	mov	edx,	dword ptr chartab[edx+edx]	; 
	mov	[ecx], edx	;
Jo1:				;
	mul	esi		;
Jo1a:				;
	mov	edx,	dword ptr chartab[edx+edx]	; 
	mov	[ecx+2], edx	;
Jo2:				;
	mul	esi		;
Jo2a:				;
	mov	edx,	dword ptr chartab[edx+edx]	; 
	mov	[ecx+4], edx	;
Jo3:				;
	mov	eax,	68DB9h	; 
	mul	ebx		; 
Jo3a:				;
	mov	edx,	dword ptr chartab[edx+edx]	;
	mov	[ecx+6], edx	;
Jo4:				;
	mul	esi		;
Jo4a:				;
	mov	edx,	dword ptr chartab[edx+edx]	;
	mov	[ecx+8], edx	;
Jo5:				;
	mul	esi		;
	mov	edx,	dword ptr chartab[edx+edx]	;
	mov	[ecx+10], edx	;
	mov	eax,	28F5C29h 	;
	mul	edi		; 
	mov	eax,	68DB9h	; 
	mov	ebx,	edx 	;
	mul	edx		;
 	mov	edx,	dword ptr chartab[edx+edx]	; 
	mov	[ecx+12], edx	;
	mul	esi		;
	mov	edx,	dword ptr chartab[edx+edx]	; 
	mov	[ecx+14], edx	;
	mul	esi		;
	mov	ebp,	[esp+2*4]	;
	mov	edx,	dword ptr chartab[edx+edx]	; 
	imul	ebx,	esi	; 
	mov	[ecx+16], edx	;
	mov	esi,	[esp+1*4]	;
	sub	edi,	ebx	; 
	mov	ebx,	[esp]	;
	add	esp,	3*4	;
	movzx	edx,	word ptr chartab[edi+edi]	;
	lea	eax,	[ecx+20]	;
	mov	edi,	[esp+2*4]    	;
	mov	[ecx+18], edx	;
	ret	2*4		;
align 16				;
Jo0:				;
	add	edx,	 30h	; 
	mov	[ecx], edx	; 
	add	ecx,	 -1	; 
	jne	Jo1		; 
align 16				;
JoNext1:				;
	mul	esi		; 
	jnc	JoNext2	; 
	cmp	edx,	9	; 
	lea	ecx,	[ecx-2]	;
	ja	Jo1a		; 
				;
	add	edx,	30h	; 
	mov	[ecx+2], edx	; 
	add	ecx,	-1	; 
	jne	Jo2		; 
align 16				;
JoNext2:				;
	mul	esi		; 
	jnc	JoNext3	; 
	cmp	edx,	9	; 
	lea	ecx,	[ecx-4]	;
	ja	Jo2a		; 
				;
	add	edx,	30h	; 
	mov	[ecx+4], edx	; 
	add	ecx,	-1	; 
	jne	Jo3		; 
align 16				;
JoNext3:				;
	mov	eax,	68DB9h	; 
	mul	ebx		; 
	jnc	JoNext4	;
	cmp	edx,	9	;
	lea	ecx,	[ecx-6]	;
	ja	Jo3a		;
				;
	add	edx,	30h	;
	mov	[ecx+6], edx	;
	add	ecx,	-1	;
	jne	Jo4		;
align 16				;
JoNext4:				;
	mul	esi		;
	lea	ecx,	[ecx-10]	;
	jnc	Jo5		;
	cmp	edx,	9	;
	lea	ecx,	[ecx+2]	;
	ja	Jo4a		;
	add	edx,	30h	;
	mov	[ecx+8], edx	;
	add	ecx,	-1	;
	jne	Jo5		;
b2a3264	endp    			;
option	prologue:prologuedef	;
option	epilogue:epiloguedef	;
;





.data
align 16
;                        high dd          low  dd         
BigNum    dd 0FFFFFFFFh, 0FFFFFFFEh
SNum       dd 0, 0FFFFFFFEh


szBuffer   	db	40 Dup(0)
szDirNameBufer db 40 Dup(0)
;The character look up table. Make sure it's aligned suitably
align 16
chartab    dw "00","10","20","30","40","50","60","70","80","90"
    dw "01","11","21","31","41","51","61","71","81","91"
    dw "02","12","22","32","42","52","62","72","82","92"
    dw "03","13","23","33","43","53","63","73","83","93"
    dw "04","14","24","34","44","54","64","74","84","94"
    dw "05","15","25","35","45","55","65","75","85","95"
    dw "06","16","26","36","46","56","66","76","86","96"
    dw "07","17","27","37","47","57","67","77","87","97"
    dw "08","18","28","38","48","58","68","78","88","98"
    dw "09","19","29","39","49","59","69","79","89","99"   


	pAnswer dd 0

.code
; 
start:
; 
    ;function tests

    invoke	uqword, addr szBuffer, addr BigNum
    print ADDR szBuffer,13,10

    invoke	b2a3264, addr szBuffer, addr BigNum 
    print ADDR szBuffer,13,10

    invoke	uqword, addr szBuffer, addr SNum
    print ADDR szBuffer,13,10

    invoke	b2a3264, addr szBuffer, addr SNum 
    print ADDR szBuffer,13,10

    invoke Sleep, 3000

    counter_begin 1000, HIGH_PRIORITY_CLASS
    invoke	uqword, addr szBuffer, addr BigNum ;
    counter_end
    print ustr$(eax)," cycles, uqword-with 64 bit number - p.dixon",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
    invoke	b2a3264, addr szBuffer, addr BigNum ;
    counter_end
    print ustr$(eax)," cycles, b2a3264-with 64 bit number - lingo",13,10

   counter_begin 1000, HIGH_PRIORITY_CLASS
    invoke	uqword, addr szBuffer, addr SNum ;
    counter_end
    print ustr$(eax)," cycles, uqword-with 32 bit number - p.dixon",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
    invoke	b2a3264, addr szBuffer, addr SNum ;
    counter_end
    print ustr$(eax)," cycles, b2a3264-with 32 bit number - lingo",13,10

    inkey "Press any key to exit..."
    exit
; 
end start



